#include "planar_quadrotor_visualizer.h"
#include <cmath>

PlanarQuadrotorVisualizer::PlanarQuadrotorVisualizer(PlanarQuadrotor *quadrotor_ptr): quadrotor_ptr(quadrotor_ptr) {}

/**
 * TODO: Improve visualizetion
 * 1. Transform coordinates from quadrotor frame to image frame so the circle is in the middle of the screen
 * 2. Use more shapes to represent quadrotor (e.x. try replicate http://underactuated.mit.edu/acrobot.html#section3 or do something prettier)
 * 3. Animate proppelers (extra points)
 */
void PlanarQuadrotorVisualizer::render(std::shared_ptr<SDL_Renderer> &gRenderer) {
    Eigen::VectorXf state = quadrotor_ptr->GetState();
    float q_x, q_y, q_theta;
    static double rotate = 0;


    /* x, y, theta coordinates */
    /* SDL_Rect rect, rectA, rectB, rectC, rectD;
     rect.x = state[0];
    rect.y = state[1]; */
    q_theta = 10*state[2];                     //zmiana
    std::cout << "Wartosc theta: " << q_theta << std::endl;
    SDL_SetRenderDrawColor(gRenderer.get(), 0x30, 0x30, 0xC8, 0x00);
    SDL_Surface* image = SDL_LoadBMP("dron.bmp");
    if(!image) std::cout << "Error loading image" << SDL_GetError() << std::endl;
    SDL_Texture* texture = SDL_CreateTextureFromSurface( gRenderer.get(), image );
    SDL_FreeSurface( image );
    image = NULL;
    if ( !texture )
		std::cout << "Error creating texture: " << SDL_GetError() << std::endl;
    SDL_Rect dst;
    dst.x = state[0];
    dst.y = state[1];
    dst.w = 200;
    dst.h = 54;
    SDL_RenderCopyEx(gRenderer.get(), texture, NULL, &dst, -q_theta, NULL, SDL_FLIP_NONE); //-q_theta
    SDL_DestroyTexture( texture );
    if(rotate != 357.5) rotate = rotate + 3.5;
    else rotate = 0;

    double centerx = state[0]+100;
    double centery = state[1]+27;
    float costheta = cos(q_theta*3.14/180);
    float sintheta = sin(q_theta*3.14/180);
    double d = sqrt(5508-5508*costheta);
    double dx3 = -sin(fabs(q_theta*3.14/180))*d*1.5;
    double dy3;
    if(q_theta < 0) dy3 = costheta*d*1.5;
    else dy3 = -costheta*d*1.5;

    double d2 = sqrt(23508-23508*costheta);
    double dx2 = sin(fabs(q_theta*3.14/180))*d2*1.5;
    double dy2;
    if(q_theta < 0) dy2 = -costheta*d*1.5;
    else dy2 = costheta*d*1.5;

    SDL_Surface* image2 = SDL_LoadBMP("smiglo.bmp");
    SDL_Texture* texture2 = SDL_CreateTextureFromSurface( gRenderer.get(), image2 );
    SDL_FreeSurface( image2 );
    image2 = NULL;
    SDL_Rect dst2;
    dst2.x = centerx - 105 + dx2;
    dst2.y = centery - 27 + dy2;
    dst2.w = 60;
    dst2.h = 10;
    SDL_RenderCopyEx(gRenderer.get(), texture2, NULL, &dst2, rotate, NULL, SDL_FLIP_NONE);
    SDL_DestroyTexture( texture2 );

    SDL_Surface* image3 = SDL_LoadBMP("smiglo.bmp");
    SDL_Texture* texture3 = SDL_CreateTextureFromSurface( gRenderer.get(), image3 );
    SDL_FreeSurface( image3 );
    image2 = NULL;
    SDL_Rect dst3;
    dst3.x = centerx + 45 +dx3;
    dst3.y = centery - 27 +dy3;
    dst3.w = 60;
    dst3.h = 10;
    SDL_RenderCopyEx(gRenderer.get(), texture3, NULL, &dst3, rotate, NULL, SDL_FLIP_NONE);
    SDL_DestroyTexture( texture3 );

}